﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace BramkaSMS_GSMService
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
            msg_type.Items.Add(new ComboboxValue(1, "SMS Tradycyjny"));
            msg_type.Items.Add(new ComboboxValue(2, "Flash SMS"));
            msg_type.Items.Add(new ComboboxValue(3, "SMS Ekonomiczny"));
            msg_type.SelectedIndex = 0;
        }

        private void send_Click(object sender, EventArgs e)
        {
            // Utworzenie obiektu Web Services
            GSMServiceAPI.GSMServicePortTypeClient ws = new GSMServiceAPI.GSMServicePortTypeClient();

           // Obiekt Account - zawiera login oraz haslo do konta API
            GSMServiceAPI.Account account = new GSMServiceAPI.Account();
            account.login = login.Text;
            account.pass = pass.Text;

            // Tablica obiektów Message - zawiera wiadomosci SMS, ktore maja byc wyslane.
            // W przykladzie jest to 1 element = 1 wiadomosc
            GSMServiceAPI.Message[] messages = new GSMServiceAPI.Message[1];
            messages[0] = new GSMServiceAPI.Message();
            messages[0].recipients = new string[] {recipient.Text}; // Numer telefonu odbiorcy
            messages[0].message = message.Text; // Tresc wiadomosci
            messages[0].sender = senderid.Text; // Pole nadawcy, z ktorym ma zostac wyslany SMS (uprzednio zdefiniowane na koncie Uzytkownika)

            ComboboxValue type = (ComboboxValue) msg_type.SelectedItem;
            messages[0].msgType = type.Id; // Typ wiadomosci SMS
            
            messages[0].unicode = unicode.Checked; // Czy wiadomosc ma byc wyslana w kodowaniu UNICODE?
            messages[0].sandbox = sandbox.Checked;

            // Wysyłanie SMS - wywolanie metody SendSMS
            GSMServiceAPI.SendSMSReturn[] sendResult = ws.SendSMS(account, messages);

            // Obsluga odpowiedzi z bramki SMS:
            logBox.Text =  "Status żądania: " + sendResult[0].status + ", Kod błędu: " + sendResult[0].errCode + ", Opis statusu: " + sendResult[0].description +
                          ", Nr odbiorcy: " + sendResult[0].recipient + ", ID wiadomości: " + sendResult[0].msgId + ", Liczba części: " + sendResult[0].parts + 
                          ", Koszt: " + sendResult[0].price + "\r\n" + logBox.Text;
        }

        private void price_Click(object sender, EventArgs e)
        {
            // Utworzenie obiektu Web Services
            GSMServiceAPI.GSMServicePortTypeClient ws = new GSMServiceAPI.GSMServicePortTypeClient();

            // Obiekt Account - zawiera login oraz haslo do konta API
            GSMServiceAPI.Account account = new GSMServiceAPI.Account();
            account.login = login.Text;
            account.pass = pass.Text;

            // Tablica obiektów Message - zawiera wiadomosci SMS, ktorych ceny maja byc sprawdzone.
            // W przykladzie jest to 1 element = 1 wiadomosc
            GSMServiceAPI.Message[] messages = new GSMServiceAPI.Message[1];
            messages[0] = new GSMServiceAPI.Message();
            messages[0].recipients = new string[] { recipient.Text }; // Numer telefonu odbiorcy
            messages[0].message = message.Text; // Tresc wiadomosci
            messages[0].sender = senderid.Text; // Pole nadawcy (uprzednio zdefiniowane na koncie Uzytkownika)

            ComboboxValue type = (ComboboxValue)msg_type.SelectedItem;
            messages[0].msgType = type.Id; // Typ wiadomosci SMS

            messages[0].unicode = unicode.Checked; // Czy ma byc policzony koszt wiadomosci w kodowaniu UNICODE?

            // Sprawdzenie ceny wyslania SMS - wywolanie metody GetPrice
            GSMServiceAPI.GetPriceReturn[] getpriceResult = ws.GetPrice(account, messages);

            // Obsluga odpowiedzi z bramki SMS:
            logBox.Text =  "Status żądania: " + getpriceResult[0].status + ", Kod błędu: " + getpriceResult[0].errCode + ", Opis statusu: " + getpriceResult[0].description +
                          ", Nr odbiorcy: " + getpriceResult[0].recipient + ", Liczba części: " + getpriceResult[0].parts + ", Koszt: " + getpriceResult[0].price + "\r\n" +logBox.Text;
        }

        private void getStatus_Click(object sender, EventArgs e)
        {
            // Utworzenie obiektu Web Services
            GSMServiceAPI.GSMServicePortTypeClient ws = new GSMServiceAPI.GSMServicePortTypeClient();

            // Obiekt Account - zawiera login oraz haslo do konta API
            GSMServiceAPI.Account account = new GSMServiceAPI.Account();
            account.login = login.Text;
            account.pass = pass.Text;

            // Tablica stringów - każdy element zawiera ID jednej wiadomości, której status ma zostać sprawdzony.
            // W przykłądzie sprawdzamy tylko 1 ID, więc jest to tablica 1-elementowa
            string[] ids_status = new string[1];
            ids_status[0] = msg_id_status.Text;
           
            // Sprawdzenie aktualnego statusu wiadomości SMS - wywolanie metody GetStatus
            GSMServiceAPI.GetStatusReturn[] getstatusResult = ws.GetStatus(account, ids_status);

            // Obsluga odpowiedzi z bramki SMS:
            logBox.Text = "Status żądania: " + getstatusResult[0].status + ", Kod błędu: " + getstatusResult[0].errCode + ", Opis statusu: " + getstatusResult[0].description +
                          ", ID wiadomości: " + getstatusResult[0].msgId + ", Nr odbiorcy: " + getstatusResult[0].recipient + ", Data wysyłki: " + getstatusResult[0].origDate +
                          ", Data ostatniej zmiany statusu: " + getstatusResult[0].doneDate + ", Status wiadomości: " + getstatusResult[0].msgStatusCode + ", Tekstowy opis statusu wiadomości: " +
                          getstatusResult[0].msgStatusDescription + ", Typ wiadomości: " + getstatusResult[0].msgType + ", Liczba części: " + getstatusResult[0].parts +
                          ", Koszt: " + getstatusResult[0].price + ", ID użytkownika: " + getstatusResult[0].extId + ", Czy Unicode?: " + getstatusResult[0].unicode + "\r\n" + logBox.Text;
        }

        private void getBalance_Click(object sender, EventArgs e)
        {
            // Utworzenie obiektu Web Services
            GSMServiceAPI.GSMServicePortTypeClient ws = new GSMServiceAPI.GSMServicePortTypeClient();

            // Obiekt Account - zawiera login oraz haslo do konta API
            GSMServiceAPI.Account account = new GSMServiceAPI.Account();
            account.login = login.Text;
            account.pass = pass.Text;

            // Sprawdzenie aktualnego stanu konta - wywolanie metody GetBalance
            GSMServiceAPI.GetBalanceReturn getbalanceResult = ws.GetBalance(account);

            // Obsluga odpowiedzi z bramki SMS:
            logBox.Text = "Status żądania: " + getbalanceResult.status + ", Kod błędu: " + getbalanceResult.errCode + ", Opis statusu: " + getbalanceResult.description +
                          ", Stan konta: " + getbalanceResult.balance + ", Waluta konta: " + getbalanceResult.currency + "\r\n" + logBox.Text;
        }

        private void Cancel_Click(object sender, EventArgs e)
        {
            // Utworzenie obiektu Web Services
            GSMServiceAPI.GSMServicePortTypeClient ws = new GSMServiceAPI.GSMServicePortTypeClient();

            // Obiekt Account - zawiera login oraz haslo do konta API
            GSMServiceAPI.Account account = new GSMServiceAPI.Account();
            account.login = login.Text;
            account.pass = pass.Text;

            // Tablica stringów - każdy element zawiera ID jednej zaplanowanej wiadomości, która ma zostać anulowana.
            // W przykłądzie anulujemy tylko 1 ID, więc jest to tablica 1-elementowa
            string[] ids_cancel = new string[1];
            ids_cancel[0] = msg_id_cancel.Text;

            // Anulowanie zaplanowanej wiadomości - wywolanie metody Cancel
            GSMServiceAPI.CancelReturn[] getcancelResult = ws.Cancel(account, ids_cancel);

            // Obsluga odpowiedzi z bramki:
            logBox.Text = "Status żądania: " + getcancelResult[0].status + ", Kod błędu: " + getcancelResult[0].errCode + ", Opis statusu: " + getcancelResult[0].description +
                          ", ID anulowanej wiadomości: " + getcancelResult[0].msgId + ", Nr odbiorcy: " + getcancelResult[0].recipient + "\r\n" + logBox.Text;
        }
    }
}
